Loading...
Searching...
No Matches
Gesture Subscription
The Simplified GEIS Interface » Gesture Types » Gesture Primitives » Standard Gesture Types » Vendor Extension Gesture Types » Initialization and Cleanup » Configuration and Control | The Advanced GEIS Interface » The Geis API Object » Error Reporting » Configuration » Input Devices » Gesture Subscription » Attributes » Event Control » Input Devices » Gesture Classes » Gesture Regions » Gesture Filter

## Topics

| Gesture Frames
| Gesture state information.

## Data Structures

class | GeisSubscription
| A gesture recognition subscription. More...

## Region Initialization Arguments

  Gesture regions are created to describe a particular display/feedback region. The type of the region can not be changed after creation (just create a new region for that). The types of regions are platform specific and each type may require addition arguments.

  The following region initialization argument names are required by the GEIS v2.0 specification.

| GEIS_SUBSCRIPTION_NONE
| No special subscription processing: this is the default.
| GEIS_SUBSCRIPTION_GRAB
| The subscription will "grab" all filtered gestures from subwindows.
| GEIS_SUBSCRIPTION_CONT
| The gesture engine will return gesture continuations, in which the class of a recognized gestire may change over the lifetime of the gesture.
enum | { GEIS_SUBSCRIPTION_NONE , GEIS_SUBSCRIPTION_GRAB , GEIS_SUBSCRIPTION_CONT }
typedef int | GeisSubscriptionFlags
GeisStatus | geis_subscription_get_configuration (GeisSubscription subscription, GeisString config_item_name, GeisPointer config_item_value)
| Gets a subscription-level configuration item.
GeisStatus | geis_subscription_set_configuration (GeisSubscription subscription, GeisString config_item_name, GeisPointer config_item_value)
| Sets a subscription-level configuration item.
GeisSubscription | geis_subscription_new (Geis geis, GeisString name, GeisSubscriptionFlags flags)
| Creates a new subscription.
GeisStatus | geis_subscription_delete (GeisSubscription subscription)
| Destroys a GEIS v2.0 subscription object.
GeisStatus | geis_subscription_activate (GeisSubscription subscription)
| Activates a subscription.
GeisStatus | geis_subscription_deactivate (GeisSubscription subscription)
| Deactivates a subscription.
GeisString | geis_subscription_name (GeisSubscription subscription)
| Gets the name given to a subscription when it was created.
GeisInteger | geis_subscription_id (GeisSubscription subscription)
| Gets the ID assigned to a subscription when it was created.
GeisStatus | geis_subscription_add_filter (GeisSubscription subscription, GeisFilter filter)
| Adds a filter to a subscription.
GeisFilter | geis_subscription_filter_by_name (GeisSubscription sub, GeisString name)
| Gets an named filter from a subscription.
GeisStatus | geis_subscription_remove_filter (GeisSubscription subscription, GeisFilter filter)
| Removes a filter from a subscription.

## Detailed Description

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
GEIS_SUBSCRIPTION_NONE | No special subscription processing: this is the default.
GEIS_SUBSCRIPTION_GRAB | The subscription will "grab" all filtered gestures from subwindows.
GEIS_SUBSCRIPTION_CONT | The gesture engine will return gesture continuations, in which the class of a recognized gestire may change over the lifetime of the gesture. If this flag is not set, a new gesture will be identified for each change in gesture class.

## Function Documentation

## geis_subscription_activate()

GeisStatus geis_subscription_activate | ( | GeisSubscription | subscription | ) |

Activates a subscription.

Parameters

  [in] | subscription | The subscription.

Puts the subscription into the active state. Gesture events will be delivered for this subscription.

## geis_subscription_add_filter()

GeisStatus geis_subscription_add_filter | ( | GeisSubscription | subscription,
|  | GeisFilter | filter )

Adds a filter to a subscription.

Parameters

  [in] | subscription | The subscription.
  [in] | filter | The filter to be added to the subscription.

The effect of filters are ORed together so that, for example, a subscription that has a filter for 3-finger drag gestures and another for 2-finger pinch gestures will produce events for both 3-finger drag gestures and 2-finger pinch gestures.

The default is no filters: that is, all possible gesture events will be reported.

The subscription will take ownership of the filter.

## geis_subscription_deactivate()

GeisStatus geis_subscription_deactivate | ( | GeisSubscription | subscription | ) |

Deactivates a subscription.

Parameters

  [in] | subscription | The subscription.

Puts the subscription into the inactive state. Gesture events will not be delivered for this subscription.

## geis_subscription_delete()

GeisStatus geis_subscription_delete | ( | GeisSubscription | subscription | ) |

Destroys a GEIS v2.0 subscription object.

Parameters

  [in] | subscription | The subscription.

## geis_subscription_filter_by_name()

GeisFilter geis_subscription_filter_by_name | ( | GeisSubscription | sub,
|  | GeisString | name )

Gets an named filter from a subscription.

Parameters

  [in] | sub | The subscription.
  [in] | name | Names the filter to retrieve.

Returns the first filter with the given name or NULL if no such named filter is found.

## geis_subscription_get_configuration()

GeisStatus geis_subscription_get_configuration | ( | GeisSubscription | subscription,
|  | GeisString | config_item_name,
|  | GeisPointer | config_item_value )

Gets a subscription-level configuration item.

Parameters

  [in] | subscription | The subscription from which the configuration item will be retrieved.
  [in] | config_item_name | The name of the configuration item.
  [out] | config_item_value | A pointer to an appropriate variable to hold the retrieved config item value.

Not all back ends support all configuration items.

Return values

  GEIS_STATUS_BAD_ARGUMENT | an invalid argument value was passed
  GEIS_STATUS_NOT_SUPPORTED | the configuration value is not supported
  GEIS_STATUS_SUCCESS | normal successful completion

## geis_subscription_id()

GeisInteger geis_subscription_id | ( | GeisSubscription | subscription | ) |

Gets the ID assigned to a subscription when it was created.

Parameters

  [in] | subscription | The subscription.

## geis_subscription_name()

GeisString geis_subscription_name | ( | GeisSubscription | subscription | ) |

Gets the name given to a subscription when it was created.

Parameters

  [in] | subscription | The subscription.

## geis_subscription_new()

GeisSubscription geis_subscription_new | ( | Geis | geis,
|  | GeisString | name,
|  | GeisSubscriptionFlags | flags )

Creates a new subscription.

Parameters

  [in] | geis | The GEIS API instance.
  [in] | name | A name.
  [in] | flags | Some flags.

Returns
  a GeisSubscription object or NULL on failure.

A gesture subscription is required for any gesture events to be delivered from the GEIS API.

## geis_subscription_remove_filter()

GeisStatus geis_subscription_remove_filter | ( | GeisSubscription | subscription,
|  | GeisFilter | filter )

Removes a filter from a subscription.

Parameters

  [in] | subscription | The subscription.
  [in] | filter | The filter to be removed from the subscription.

Ownership of the filter is passed to the caller.

## geis_subscription_set_configuration()

GeisStatus geis_subscription_set_configuration | ( | GeisSubscription | subscription,
|  | GeisString | config_item_name,
|  | GeisPointer | config_item_value )

Sets a subscription-level configuration item.

Parameters

  [in] | subscription | The subscription from which the configuration item will be retrieved.
  [in] | config_item_name | The name of the configuration item.
  [in] | config_item_value | A pointer to an appropriate variable holding the config item value.

Not all back ends support all configuration items.

Return values

  GEIS_STATUS_BAD_ARGUMENT | an invalid argument value was passed
  GEIS_STATUS_NOT_SUPPORTED | the configuration value is not supported
  GEIS_STATUS_SUCCESS | normal successful completion